//// Ejercicio 6-5 ////
////---------------////
clear;
clc;

// Modelo de estados continuo//
A = [0 1;0 -10];
B = [0;10];
C = [1 0];   // La salida es la variable x1
D = 0;

Gp=syslin('c',A,B,C,D);


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//------- Modelo de estado de la planta ----------
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

// Cálculo matriz de transicion de estados
s = poly(0,"s");            // Variable de Laplace
I_2 = eye(2,2);             // Matriz identidad de 2x2
sia = s*I_2-A              // sI-A
adj_sia = coffg(sia);       // Adj(sI-A)
det_sia = det(sia);         // Det(sI-A)
inv_sia = adj_sia/det_sia  // (sI-A)^-1

// Descomposición en fracciones parciales

// Elemento 1,1
T11=pfss(inv_sia(1,1))
// Elemento 1,2
T12=pfss(inv_sia(1,2))
// Elemento 2,1
T21=pfss(inv_sia(2,1))
// Elemento 2,2
T22=pfss(inv_sia(2,2))



//-------------------------------------------------------
// Calculo elementos de Ad
//-------------------------------------------------------

Ts=1/10; //Periodo de muestreo

// -------- Elemento Ad11 --------------
P1=roots(T11(1).den);
res1=T11(1).num;
Ad11=res1*exp(P1*Ts);

// -------- Elemento Ad12 --------------
P1=roots(T12(2).den);
res1=T12(2).num;
P2=roots(T12(1).den);
res2=T12(1).num;
Ad12=res1*exp(P1*Ts)+res2*exp(P2*Ts)

// -------- Elemento Ad21 --------------
Ad21=0;

// -------- Elemento Ad22 --------------
P1=roots(T22(1).den);
res1=T22(1).num;
Ad22=res1*exp(P1*Ts);

AP=[Ad11 Ad12; Ad21 Ad22]


//-------------------------------------------------------
// Calculo elementos de Bd
//-------------------------------------------------------

TB=inv_sia*B
TB11=pfss(TB(1,1))
TB21=pfss(TB(2,1))



// -------- Elemento Bd11 --------------
P1=roots(TB11(1).den);
P2=roots(TB11(2).den);
res1=TB11(1).num;
res2=TB11(2).num;

Bd11=(res1*Ts)+(res2/P2)*exp(P2*Ts)-(0+(res2/P2));

// -------- Elemento Bd21 --------------
P1=roots(TB21(1).den);
res1=TB21(1).num;

Bd21=((res1/P1)*exp(P1*Ts))-(res1/P1);


BP=[Bd11;Bd21]

// El modelo se completa

CP=C;
DP=D;

//---------------------------------------------------------------
// Con Scilab el pasaje el modelo continuo a discreto es directo
Gp=syslin('c',A,B,C,D);
Gpd=dscr(Gp,Ts);
[Ad,Bd,Cd,Dd]=abcd(Gpd);

// Comparativa matrices A y B
Ad
AP

Bd
BP
//---------------------------------------------------------------

[N,Nx]=size(Ad); // En N se registra el tamaño de la matriz cuadrada


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//------- Modelo de estado del retardo ----------
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx


Td=0.3;
Nd=ceil(Td/Ts)   // Cantidad de muestras de retardo [redondeo hacia arriba]

// ---------- Crea las matrices de retardo con la forma canonica ----------
AR=zeros(Nd,Nd);      // Matriz AR
for i=1:(Nd-1)
    AR(i,(i+1))=1;
end

BR=zeros(Nd,1);
BR(Nd,1)=1;         // Matriz BR

CR=zeros(1,Nd);     // Matriz CR
CR(1,1)=1;
// ---------- Crea las matrices de retardo con la forma canonica ----------




//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//------- Modelo de estado total PARTE A----------
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

AT=[AP zeros(N,Nd); BR*CP AR]
BT=[BP;zeros(Nd,1)]
CT=[zeros(1,N) CR]

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//------- Modelo de estado total PARTE B----------
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

AT2=[AP BP*CR; zeros(Nd,N) AR]
BT2=[zeros(N,1); BR]
CT2=[CP zeros(1,Nd)]

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

